import { useResource } from "@/modules/resource";
import MaterialTemplateModal from "@/modules/resource/components/ResourceManager/MaterialTemplateModal";
import { defineComponent } from "vue";
import { SourceController } from "./SourceController";
import MaterialUI from "./UI";

export default defineComponent({
  setup() {
    const resource = useResource();
    const { controls, actions } = resource;

    const showModal = (type: string) => {
      resource.showModal(<MaterialTemplateModal type={type} />, {
        title: `${type === "image" ? "图片" : "视频"}模板中心`,
        width: "1000px",
      });
    };
    const ctrl = new SourceController();
    ctrl.imageCtrl = controls.materialImageListCtrl;
    ctrl.vidoeCtrl = controls.materialVideoListCtrl;
    ctrl.taskCtrl = controls.renderTaskListCtrl;
    ctrl.onBtnClick = async function(name: string) {
        if (name == "upload") {
           const uploaded = await resource.actions.uploadMaterial()
            ctrl.switchTab(uploaded.fileType, false);
            ctrl.getCurrControl().loadPage(1);
            return;
        }
        
        showModal(name);
    }
    ctrl.onItemClick = function(name, record) {
        if (name == "delete") return actions.deleteMaterial(record);
        return actions.downloadMaterial(record)
    }
    
    return () =>  (
        <MaterialUI Controller={ ctrl } />
    )
  },
});
